local mod = RW:Boss("Broodlord Lashlayer", "Blackwing Lair")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_nefarion]]

---------------------------
-- Variables

-- Mortal Strike
local tMortalDur, mMortal, wMortal

-- KNock
local wKnock

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		-- Register locale variables
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(12017)
	self:SetWin(12017)
	
	-- Mortal Strike
	tMortalDur		= self:DurTargetTimer(5, 24573)
	mMortal			= self:TargetMessage(24573)
	wMortal			= self:OnYouWarning(24573)
	
	-- Knockback
	wKnock			= self:CastWarning(18670)
end

---------------------------
-- Locals

-- API Functions

function mod:OnEngage(trigger)
	self:Track("Mortal", 24573)
	self:Track("Knockback", 18670)
end

function mod:Mortal(event, args)
	if event == "SPELL_AURA_APPLIED" then
		tMortalDur:Start(args.dName)
		mMortal:Show(args.dName)
	end
end

function mod:Knockback(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		wKnock:Show()
	end
end