local mod = RW:Boss("Nefarian", "Blackwing Lair")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_nefarion]]

---------------------------
-- Variables

-- Class calls
local wCall, tCallCD, mCall

-- Phase changes
local wP2, wP3

-- Shadow
local mShadow

-- Fear
local wFear, tFearCD

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.Pull	= "Let the games begin!"
		L.P2	= "Well done, my minions. The mortals' courage begins to wane! Now, let's see how they contend with the true Lord of Blackrock Spire!!!"
		L.P3	= "Impossible! Rise my minions!  Serve your master once more!"
		
		L.PhaseOpt = "Phase changes"
		L.P2Warning = "Nefarian Landing!"
		L.P3Warning = "Zerg incoming!"
		
		L.Call_Next = "Next call"
		L.Call	= "%s Call!"
		L.Call_opt	= "Class calls"
		
		-- Class calls from Bigwigs
		L.Shaman	= "Shamans, show me"
		L.Druid		= "Druids and your silly"
		L.Warlock 	= "Warlocks, you shouldn't be playing"
		L.Priest	= "Priests! If you're going to keep"
		L.Hunter	= "Hunters and your annoying"
		L.Warrior	= "Warriors, I know you can hit harder"
		L.Rogue 	= "Rogues%? Stop hiding"
		L.Paladin	= "Paladins"
		L.Mage		= "Mages too%?"
		L.Deathknight = "Deathknight "
	end
	L = mod:GetLocale()
	self.L = L
	
	self:AddEmoteTrigger(L.Pull)
	self:AddMobTrigger(14302, 14264, 14261, 14262, 14265, 14263, 11583) --Chromatic, Red, Blue, Green, Black, Bronze, Nefarian
	self:SetWin(11583)
	
	-- Calls
	mCall			= self:CustomMessage(L.Call, L.Call_opt, [[Interface\Icons\Ability_Creature_Cursed_04]])
	tCallCD			= self:CustomTimer(30, L.Call_Next, L.Call_opt, [[Interface\Icons\Ability_Creature_Cursed_04]])
	wCall			= self:CustomWarning(L.Call, L.Call_opt, [[Interface\Icons\Ability_Creature_Cursed_04]])
	
	-- Phase changes
	wP2				= self:CustomWarning(L.P2Warning, L.PhaseOpt, [[Interface\Icons\Achievement_PVP_A_01]])
	wP3				= self:CustomWarning(L.P3Warning, L.PhaseOpt, [[Interface\Icons\Achievement_Ladydeathwhisper]])
	
	-- Shadow
	mShadow			= self:TargetMessage(22687)
	
	-- Fear
	tFearCD			= self:CDTimer(30, 22686)
	wFear			= self:CastWarning(22686)
end

---------------------------
-- Locals

-- API Functions
function mod:OnEngage(trigger)
	self:Track("Shadow", 22687)
	self:Track("Fear", 22686)

	self:YellTrack("Shaman", L.Shaman)
	self:YellTrack("Druid", L.Druid)
	self:YellTrack("Warlock", L.Warlock)
	self:YellTrack("Priest", L.Priest)
	self:YellTrack("Hunter", L.Hunter)
	self:YellTrack("Warrior", L.Warrior)
	self:YellTrack("Rogue", L.Rogue)
	self:YellTrack("Paladin", L.Paladin)
	self:YellTrack("Mage", L.Mage)
	self:YellTrack("Deathknight", L.Deathknight)
	
	self:YellTrack("Phase2", L.P2)
	self:YellTrack("Phase3", L.P3)

	if type(trigger) == "string" and trigger:find(L.Pull) then
	end
end

function mod:Shadow(event, args)
	if event == "SPELL_AURA_APPLIED" then
		mShadow:Show(args.dName)
	end
end

function mod:Fear(event, args)
	if event == "SPELL_CAST_START" then
		wFear:Show()
		tFearCD:Start()
	end
end

do -- Class calls
	function mod:Shaman(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["SHAMAN"])
		if self.pClass == "SHAMAN" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["SHAMAN"])
		end
		tCallCD:Start()
	end
	
	function mod:Druid(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["DRUID"])
		if self.pClass == "DRUID" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["DRUID"])
		end
		tCallCD:Start()
	end

	function mod:Warlock(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["WARLOCK"])
		if self.pClass == "WARLOCK" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["WARLOCK"])
		end
		tCallCD:Start()
	end

	function mod:Priest(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["PRIEST"])
		if self.pClass == "PRIEST" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["PRIEST"])
		end
		tCallCD:Start()
	end

	function mod:Hunter(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["HUNTER"])
		if self.pClass == "HUNTER" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["HUNTER"])
		end
		tCallCD:Start()
	end

	function mod:Warrior(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["WARRIOR"])
		if self.pClass == "WARRIOR" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["WARRIOR"])
		end
		tCallCD:Start()
	end

	function mod:Rogue(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["ROGUE"])
		if self.pClass == "ROGUE" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["ROGUE"])
		end
		tCallCD:Start()
	end

	function mod:Paladin(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["PALADIN"])
		if self.pClass == "PALADIN" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["PALADIN"])
		end
		tCallCD:Start()
	end

	function mod:Mage(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["MAGE"])
		if self.pClass == "MAGE" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["MAGE"])
		end
		tCallCD:Start()
	end

	function mod:Deathknight(event, message, name)
		mCall:Show(LOCALIZED_CLASS_NAMES_MALE["DEATHKNIGHT"])
		if self.pClass == "DEATHKNIGHT" then
			wCall:Show(LOCALIZED_CLASS_NAMES_MALE["DEATHKNIGHT"])
		end
		tCallCD:Start()
	end
end

function mod:Phase2()
	wP2:Show()
end

function mod:Phase3()
	wP3:Show()
end
